<template>
    <div>
        <label
            v-if="!hideLabel"
            class="block text-sm font-medium capitalize"
            :class="{
                'border-red-500': computedErrors && computedErrors.length,
                'text-red-500': computedErrors && computedErrors.length,
                'font-black': boldLabel,
            }"
        >
            {{ label }}
        </label>
        <div class="mt-1 relative rounded-sm shadow-sm">
            <div class="flex justify-start">
                <div class="relative w-[67px]">
                    <select
                        v-model="countryData"
                        class="form-control !rounded-tr-none !rounded-br-none"
                        :class="{
                            'disabled': readonly || disabled,
                            'text-red-500': computedErrors && computedErrors.length,
                        }"
                        :disabled="disabled || readonly"
                        @input="countryData = $event.target.value"
                    >
                        <option
                            value=""
                            :selected="String(countryData) === ''"
                        >
                            {{ placeholder || $t('all') }}
                        </option>
                        <option
                            v-for="(opt, i) in options"
                            :key="`${contactCountryName}-${i}`"
                            :value="opt.value"
                            :selected="String(countryData) === String(opt.value)"
                        >
                            {{ opt.text }}
                        </option>
                    </select>
                    <div
                        class="pointer-events-none absolute inset-y-0 right-0 flex items-center px-2 text-gray-700"
                        :class="{
                            'text-red-500': computedErrors && computedErrors.length,
                        }"
                    >
                        <svg class="fill-current h-4 w-4" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20"><path d="M9.293 12.95l.707.707L15.657 8l-1.414-1.414L10 10.828 5.757 6.586 4.343 8z"/></svg>
                    </div>
                </div>
                <input
                    :id="id"
                    type="number"
                    :name="contactNumberName"
                    :placeholder="placeholder"
                    :value="numberData"
                    :disabled="disabled"
                    :readonly="readonly"
                    class="form-control flex-1 !appearance-none !rounded-tl-none !rounded-bl-none"
                    :class="{
                        'border-gray-300': !errors,
                        'border-red-500': errors && errors.length,
                        'text-red-500': errors && errors.length,
                        'opacity-50': disabled || readonly
                    }"
                    @input="numberData = $event.target.value"
                    @keypress="checkForRestriction"
                >
            </div>
        </div>
        <div
            v-if="note && Array.isArray(note)"
        >
            <div
                v-for="(n, i) in note"
                :key="`note-${i}`"
            >
                <div class="font-light font-sm">{{ n }}</div>
            </div>
        </div>
        <div
            v-else-if="note && !Array.isArray(note)"
        >
            <div class="font-light font-sm">{{ note }}</div>
        </div>
        <div
            v-if="computedErrors && computedErrors.length"
        >
            <div
                v-for="(err, i) in computedErrors"
                :key="i"
            >
                <div class="font-light font-sm text-red-500">{{ err }}</div>
            </div>
        </div>
    </div>
</template>

<script setup>
import {computed, nextTick, onMounted, ref, watch} from 'vue';
import {useSettingStore} from "~/stores/setting.js";
const props = defineProps({
    id: {
        required: false,
        type: [String, Number],
        default: null,
    },
    label: {
        required: false,
        type: [String, Number],
        default: null,
    },
    boldLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    hideLabel: {
        required: false,
        type: Boolean,
        default: false,
    },
    contactCountryName: {
        required: false,
        type: String,
        default: 'contact_country_id',
    },
    contactNumberName: {
        required: false,
        type: String,
        default: 'contact_number',
    },
    placeholder: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    note: {
        required: false,
        type: [String, Number, Array],
        default: null,
    },
    selectValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    inputValue: {
        required: false,
        type: [String, Number, Boolean],
        default: '',
    },
    errors: {
        required: false,
        type: [Array, Object],
        default: () => [],
    },
    disabled: {
        required: false,
        type: Boolean,
        default: false,
    },
    readonly: {
        required: false,
        type: Boolean,
        default: false,
    }
});
let countryData = ref(props.selectValue);
let numberData = ref(props.inputValue);
const $settingStore = useSettingStore();

const emit = defineEmits(['update:selectValue', 'update:inputValue']);

const options = computed(() => {
    return $settingStore.extForOptions;
});

const computedErrors = computed(() => {
    if (!props.errors) return null;
    let a = [];
    if (props.errors[props.contactCountryName]) {
        props.errors[props.contactCountryName].forEach(r => {
            a.push(r);
        });
    }

    if (props.errors[props.contactNumberName]) {
        props.errors[props.contactNumberName].forEach(r => {
            a.push(r);
        });
    }
    return a;
});

watch(countryData, (newValue) => {
    emit('update:selectValue', newValue);
});
watch(numberData, (newValue) => {
    emit('update:inputValue', newValue);
});

const checkForRestriction = (event) => {
    let keyCode = (event.keyCode ? event.keyCode : event.which);

    // only allow number
    if (keyCode < 48 || keyCode > 57) {
        event.preventDefault();
    }
};

onMounted(async () => {
    await nextTick(() => {
        if (!countryData.value) {
            if ($store.state['settings'].settings.default_country_id) {
                countryData.value = $store.state['settings'].settings.default_country_id;
                emit('update:selectValue', $store.state['settings'].settings.default_country_id);
            }
        }
    })
});
</script>
